package leigh.android.test;

import leigh.eo.EO;
import leigh.esp.sdk.ClientContext;
import leigh.esp.sdk.EOResponseConsumer;

/**
 * Example class for making ESP service requests. This starts another thread since Android prevents performing network
 * requests on the main thread.
 *
 * @author C. Alexander Leigh
 */
public class NetworkRunner implements Runnable {
    private final ClientContext ctx;

    public NetworkRunner() {
        ctx = new ClientContext("https://leigh-co.com/");
        // Run myself
        new Thread(this).start();
    }

    @Override
    public void run() {
        try {
            ctx.apiRequest("/minecraft/neweden/link/v1/shops/read", new EO(), new EOResponseConsumer() {
                @Override
                public void handle(EO eo) throws Exception {
                    System.out.println("obj : " + eo);
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
