package leigh.esp.sdk;

import leigh.eo.EO;
import leigh.eo.schema.DAOGenerator;
import leigh.eo.schema.dao.ElementElementDAO;
import leigh.eo.schema.dao.SchemaElementDAO;
import leigh.eo.schema.dao.SchemaUtil;
import leigh.mecha.log.MechaLogger;
import leigh.mecha.log.MechaLoggerFactory;
import leigh.mecha.util.UniversalJob;

import java.io.File;
import java.io.FileNotFoundException;

public class SchemaGeneratorApp {
    private static final MechaLogger logger = MechaLoggerFactory.getLogger(SchemaGeneratorApp.class);

    public static EO generate() {
        final EO schema = SchemaUtil.create(SchemaUtil.API_KEY);

        final EO moveEvent = ElementElementDAO.create();
        SchemaElementDAO.getElements(schema).add(moveEvent);
        ElementElementDAO.setApiName(moveEvent, "leigh.esp.link23.Heartbeat");

        return schema;
    }

    public static void main(final String... args) throws FileNotFoundException {
        UniversalJob.banner(logger, "Apotheosis mk3", "2014 C. Alexander Leigh");
        final EO schema = generate();
        final DAOGenerator gen = new DAOGenerator(new File("leigh-esp-sdk/src/main/java"));
        gen.generateJava("leigh.esp.sdk.link23.schema", schema);

        logger.info("Generated schema: {}", schema);
    }
}
