/*
 * Copyright (c) 2004-2017, by C. Alexander Leigh.
 * All rights reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 */

package leigh.mecha.nio;

import java.nio.ByteBuffer;

/**
 * Utility methods for working with the <code>ByteBuffer</code> class.
 *
 * @author C. Alexander Leigh
 */
public class ByteBufferUtil {
    /**
     * Return a <code>byte[]</code> representing the contents of the given <code>ByteBuffer</code>. If the
     * <code>ByteBuffer</code> is read-only then the contents of the buffer will be copied into newly allocated space
     * . Otherwise, the <code>byte[]</code> backing the <code>ByteBuffer</code> is returned.
     *
     * @param buf
     * @return
     */
    public static byte[] array(ByteBuffer buf) {
        if (!buf.isReadOnly()) return buf.array();

        byte[] b = new byte[buf.remaining()];
        buf.rewind();
        buf.get(b);

        return b;
    }

}
